stages:
  - build
  - test
  - release
  - deploy

variables:
  BUILD_DIR: /builds/lucina.ravenwing/YGOCollectionBackend
  BACKEND_BUILD: ~/build/backend/BackendBuild
  SERVER_DIR: /home/$SERVER_USER/build/YGOCollectionBackend
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA

build:
  stage: build
  image: mcr.microsoft.com/dotnet/sdk:8.0
  script:
    - echo 'Starting build stage.'

    - cat ${APP_SETTINGS} >> ./appsettings.json
    - cat ${NLOG_CONFIG} >> ./nlog.config
      
    - dotnet build
      
    - echo 'Build stage complete.'

test:
  stage: test
  image: mcr.microsoft.com/dotnet/sdk:8.0
  script:
    - echo 'Starting test stage.'

    - dotnet build
    - dotnet test ./YGOCollectionBackend_UnitTests/bin/Debug/net8.0/YGOCollectionBackend_UnitTests.dll

    - echo 'Test stage complete.'

release:
  rules:
    - if: ($CI_COMMIT_BRANCH == 'master' || $CI_PIPELINE_SOURCE == 'merge_request_event')

  stage: release
  image: docker:latest

  script:
    - echo 'Starting release stage.'
  
    - echo "Preparing environment..."
    
    - mkdir -p ~/.ssh
    - touch ~/.ssh/known_hosts
    
    - cat ${ID_RSA} > ~/.ssh/id_rsa
    - chmod 0400 ~/.ssh/id_rsa
    
    - ssh-keyscan -t rsa  $SERVER_IP >> ~/.ssh/known_hosts

    - echo 'Creating release version and archiving old version.'

    - cat ${APP_SETTINGS} >> ./YGOCollectionBackend/appsettings.json
    - cat ${NLOG_CONFIG} >> ./YGOCollectionBackend/nlog.config

    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP 'rm -r ~/build/backend/archive/BackendBuild || true'
    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP 'mv ~/build/backend/BackendBuild ~/build/backend/archive || true'

    - scp -i ~/.ssh/id_rsa -r . $SERVER_USER@$SERVER_IP:/home/$SERVER_USER/build/backend/BackendBuild
                            
    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP 'dotnet publish ~/build/backend/BackendBuild/YGOCollectionBackend/YGOCollectionBackend.csproj -c RELEASE -o ~/build/backend/BackendBuild/Release'

    - echo "Pushing Docker images to Docker Hub..."
    
    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP "cd /home/$SERVER_USER/build/backend/BackendBuild; docker build -t lucinaravenwing/ygo-collection-backend -t $TAG_LATEST -t $TAG_COMMIT .; echo "$DOCKER_PASSWORD" | docker login --username "$DOCKER_USERNAME" --password-stdin; docker push lucinaravenwing/ygo-collection-backend:latest"

deploy:
  rules:
    - if: ($CI_COMMIT_BRANCH == 'master' || $CI_PIPELINE_SOURCE == 'merge_request_event')

  stage: deploy
  image: docker:latest
  services:
    - name: docker:dind
      alias: docker
      command: [ "--tls=false" ]
  script:
    - echo 'Starting deploy stage.'

    - echo "Preparing environment..."
    
    - mkdir -p ~/.ssh
    - touch ~/.ssh/known_hosts
    
    - cat ${ID_RSA} > ~/.ssh/id_rsa
    - chmod 0400 ~/.ssh/id_rsa
    
    - ssh-keyscan -t rsa  $SERVER_IP >> ~/.ssh/known_hosts

    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP "docker stop ygo-collection-backend || true"
    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP "docker rm ygo-collection-backend || true"
    - ssh -i ~/.ssh/id_rsa $SERVER_USER@$SERVER_IP "docker run -d -it --network=host --name=ygo-collection-backend -v logs:/logs lucinaravenwing/ygo-collection-backend"